﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using System.Diagnostics;

namespace UltraGridBandHierarchy
{
    public partial class Form1 : Form
    {
        BindingList<MyMainClass> BList;
        public Form1()
        {
            InitializeComponent();
            BList = new BindingList<MyMainClass>();
            ultraGrid1.DataSource = BList;

            ultraGrid1.DisplayLayout.Bands[0].Groups.Add("Key1", "GROUP HEADER");
            ultraGrid1.DisplayLayout.Bands[0].Groups["Key1"].Columns.Add(ultraGrid1.DisplayLayout.Bands[0].Columns[0]);
            ultraGrid1.DisplayLayout.Bands[0].Groups["Key1"].Columns.Add(ultraGrid1.DisplayLayout.Bands[0].Columns[1]);
            ultraGrid1.DisplayLayout.Bands[0].GroupHeadersVisible = true;
            ultraGrid1.DisplayLayout.Bands[0].ColHeadersVisible = true;

            ultraGrid1.DisplayLayout.Override.CellClickAction = CellClickAction.RowSelect;
            ultraGrid1.ClickCell += new ClickCellEventHandler(ultraGrid1_ClickCell);

        }

        void ultraGrid1_ClickCell(object sender, ClickCellEventArgs e)
        {

            ultraGrid1.Rows[e.Cell.Row.Index].ChildBands[0].Rows[e.Cell.Row.Index].Delete();
            ultraGrid1.Refresh();
        }


        private void Form1_Load(object sender, EventArgs e)
        {
            for (int i = 0; i < 5; i++)
            {
                MyMainClass mainClsss = new MyMainClass();
                mainClsss.MainText_1 = "Test " + (i + 1).ToString();
                mainClsss.MainText_2 = "Item " + (i + 1).ToString();
                mainClsss.ChidList = new List<MyChildClass>();

                for (int k = 0; k < 10; k++)
                {
                    MyChildClass childClass = new MyChildClass();
                    childClass.ChildText_1 = "Child Test " + (k + 1).ToString();
                    childClass.ChildText_2 = "Child Item " + (k + 1).ToString();
                    for (int j = 0; j < 10; j++)
                    {
                        MyChildClass childChildClass = new MyChildClass();
                        childChildClass.ChildText_1 = "Child2 Test " + (k + 1).ToString();
                        childChildClass.ChildText_2 = "Child2 Item " + (k + 1).ToString();
                    }

                    mainClsss.ChidList.Add(childClass);
                }

                BList.Add(mainClsss);
            }
        }

        private void button1_Click_1(object sender, EventArgs e)
        {
            ultraGridExcelExporter1.Export(ultraGrid1, Environment.GetFolderPath(Environment.SpecialFolder.Desktop).ToString() + @"\Test.xls");
            Process.Start(Environment.GetFolderPath(Environment.SpecialFolder.Desktop).ToString() + @"\Test.xls");
        }

        private void button2_Click(object sender, EventArgs e)
        {
            ultraGrid1.DisplayLayout.Bands[0].ColHeadersVisible = true;
            ultraGridExcelExporter1.Export(ultraGrid1, Environment.GetFolderPath(Environment.SpecialFolder.Desktop).ToString() + @"\Test.xls");
            Process.Start(Environment.GetFolderPath(Environment.SpecialFolder.Desktop).ToString() + @"\Test.xls");
        }

    }

    #region MyClasses
    public class MyMainClass
    {
        #region Properties
        private string _mainText_1;

        public string MainText_1
        {
            get { return _mainText_1; }
            set { _mainText_1 = value; }
        }
        private string _mainText_2;

        public string MainText_2
        {
            get { return _mainText_2; }
            set { _mainText_2 = value; }
        }
        List<MyChildClass> _chidList;

        public List<MyChildClass> ChidList
        {
            get { return _chidList; }
            set { _chidList = value; }
        }
        #endregion
    }

    public class MyChildClass
    {
        #region Properties
        private string _childText_1;

        public string ChildText_1
        {
            get { return _childText_1; }
            set { _childText_1 = value; }
        }
        private string _childText_2;

        public string ChildText_2
        {
            get { return _childText_2; }
            set { _childText_2 = value; }
        }

        #endregion
    }
    #endregion
}
